/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import java.io.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import view.GraphDataObserver;

/**
 *
 * @author danecek
 */
public class Data {

    private static Data instance;
    List<GraphObject> data = new ArrayList<>();
    Collection<GraphDataObserver> observers = new ArrayList<>();

    public void addObserver(GraphDataObserver dobs) {
        observers.add(dobs);
    }

    private void fire() {
        for (GraphDataObserver observer : observers) {
            observer.dataChanged();
        }
    }

    /**
     * @return the instance
     */
    public static Data getInstance() {
        if (instance == null) {
            instance = new Data();
        }
        return instance;
    }

    private Data() {
    }

    public Collection<GraphObject> getAll() {
        return data;
    }

    public void deleteAll() {
        data.clear();
        fire();
    }

    public void add(GraphObject go) {
        data.add(go);
        fire();
    }

    public GraphObject get(int rowIndex) {
        return data.get(rowIndex);
    }

    public void save(File f) throws IOException {
        ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(f));
        oos.writeObject(data);

    }

    public void load(File f) throws IOException, ClassNotFoundException {
        ObjectInputStream oos = new ObjectInputStream(new FileInputStream(f));
        data = (List<GraphObject>) oos.readObject();
        fire();

    }
}
