/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package view.table;

import java.awt.Color;
import javax.swing.table.AbstractTableModel;
import model.Data;
import model.GraphObject;
import view.GraphDataObserver;

/**
 *
 * @author danecek
 */
public class GraphTableModel extends AbstractTableModel implements GraphDataObserver {

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "Type";
            case 1:
                return "X";
            case 2:
                return "Y";
            case 3:
                return "Size";
            case 4:
                return "Color";
        }
        return null;
    }

    public GraphTableModel() {
        Data.getInstance().addObserver(this);
    }

    @Override
    public int getRowCount() {
        return Data.getInstance().getAll().size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        GraphObject o = Data.getInstance().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return o.getClass().getSimpleName();
            case 1:
                return o.getRef().getX();
            case 2:
                return o.getRef().getY();
            case 3:
                return o.getSize();
            case 4: {
                Color c = o.getColor();
                return String.format("[%d, %d, %d]", c.getRed(), c.getGreen(), c.getBlue());
            }
        }
        return null;

    }

    @Override
    public void dataChanged() {
        fireTableDataChanged();
    }
}
